%fixme

\section{Introduction}
In this Chapter I will discuss various independent (small-scale) development work
for the GstLAL search pipeline.


\section{(Past work) Quick follow-up analysis tool for gravitational-wave events from the low-latency GstLAL analysis}
\subsection{\underline{Introduction and motivation}}
In the low-latency GstLAL analysis during the first half of LVK's fourth observing run O4a, 
triggers passing a FAR threshold of $1$ per hour are automatically uploaded to the 
Gravitational-wave Candidate Event Database (GraceDB). Candidate information, including the 
template parameters, SNR timeseries, $\xi^2$, and the noise power spectral density (PSD) around the time
of the candidate, are uploaded to GraceDB. Separate python packages include ``GwCelery" and ``BAYESTAR" \cite{Singer:2015ema}
are then automatically run to perform follow-up analyses on the candidate event, including the geneartion of
skymap for the candidate gravitational-wave source.

It is probable that during the course of the low-latency analysis, data from one or more detectors are stalled
and is not ingested by the GstLAL search pipeline (GstLAL will assume data is not available from the detector
after some certain wait time), and hence the uploaded candidate does not contain SNR information with respect to
some detectors, when data is actually available.
``BAYESTAR" takes in SNR timeseries of a candidate event to estimate the source localization through
Bayesian inference \cite{Singer:2015ema}. For candidate events that are likely to have detectable electromagnetic
counterparts
\footnote{
	These events are also known as EM bright events.
},
it is important to have the localization of the candidate event's source as accurate as possible. An accurate
and well-constrained skymap for the candidate event improves the chance of EM astronomers to detect EM counterparts
associated with the candidate event, and hence allowing us to extract more information about the source of the
candidate event.
It is therefore highly motivated to have a quick follow-up tool that allows one to quickly re-analyze uploaded events
with data that are not available prior to the upload and produce SNR timeseries from all participating detectors in
order to localize the event source as much as possible.

A quick follow-up script in the form of a Makefile exists for LVK's first three observing runs (O1, O2 and O3), but
(1) it is poorly written with a lot of hard-coding, and 
(2) a lot of functionalities used in the Makefile are outdated and no longer useable.
In the next subsection, I introduce an updated workflow I have written in python for the quick follow-up script
that is more user-friendly and up-to-date. 

\subsection{\underline{Overview of the workflow}}

The new workflow of the quick follow-up tool goes as follow:
(1) The user supplies a GEvent ID (GID)
\footnote{
	The GEvent ID is an event label assigned to an event uploaded to GraceDB automatically.
}
to the python script ``event\_followup.py".
(2) The python script will automatically download the ``coinc.xml" file associated with the event.
The ``coinc.xml" file contains crucial information about the event, including template parameters,
SNR timeseries and noise power spectral density (PSD) around the time of the trigger, as well as
the run directory of the low-latency GstLAL analysis at the time when the event was being uploaded
on the LIGO computing cluster.
(3) The script ingests the ``coinc.xml" file and copies over necessary files, including the population
model, template bank and related ranking statistic files to the current path from the run directory 
of the low-latency GstLAL analysis.
(4) The script regenerates the noise power spectral densities for all participating detectors with available data. 
(5) The script runs ``gstlal\_inspiral" to re-filter data around the time of the trigger, and generates
corresponding SNR timeseries for the trigger per participating detector.
The final outputs of the script are (1) An LIGOLW-XML file containing the SNR timeseries of the trigger
for all participating detectors, and (2) a plot of the SNR timeseries of the trigger for all participating detectors.

\subsection{\underline{Working example}}
As an example, the python script is run on an O4a uploaded event ``G447746" (corresponding to the Superevent S231020bw).
Figure \ref{fig:example_gstlal_quick_followup} shows the resulting SNR timeseries for the event in both the Hanford (H1) and Livingston (L1) detectors.

\begin{figure}[hbt!]
\centering
\includegraphics[width=\textwidth]{example_gstlal_quick_followup}
\caption{
	The reconstructed SNR timeseries for the O4a event ``G447746" (corresponding to the Supereevnt S231020bw)
	in both the Hanford (H1, top) and Livingston (L1, bottom) detectors, generated using the updated
	quick follow-up script ``event\_followup.py".
}
\label{fig:example_gstlal_quick_followup}
\index{figures}
\end{figure}


\section{(Past work) Investigating the effect of changing the Fast-Fourier-Transform (FFT) data length of the noise Power Spectral Density (PSD) from the standard $32$ seconds to $4$ seconds}
\subsection{\underline{Introduction and motivation}}
In LVK's first two observing runs (O1 and O2), the typical offline GstLAL analysis partition the strain data into blocks of $32$ seconds.
Each block of data is then windowed and Fourier Transformed to estimate the noise power spectral densities for the block of data.
A median PSD is then evaluated across all the blocks of partitioned data as a representation of the typical noise PSD throughout the
full stretch of data.

In the third observing run O3, however, the duration of each data partition has been reduced to $8$ seconds without prior testing
or investigation. In this section, we perform a preliminary test to check and test the validity of the aforementioned change. 

\subsection{\underline{Setup of the control and test runs}}
We set up two GstLAL offline analyses (the ``Control" run and ``Test" run)  with identical settings 
(e.g. identical template bank, data search time range) and the same injection set generated following \cite{Sachdev:2019vvd}. 

The ``Control" and ``Test" run only differ from each other in terms of the ``PSD-FFT-length" (i.e. the duration of each data partition
used for estimating the noise PSD): The ``Control" run has a ``PSD-FFT-length" of $32$ seconds, and the ``Test" run has a ``PSD-FFT-length"
of $8$ seconds. 

The two runs search through Hanford, Livingston and Virgo data between GPS time 1238166018 and 1238787954.
 
\subsection{\underline{Results}}
Figure \ref{fig:gstlal_4s_run_psd} and \ref{fig:gstlal_32s_run_psd} shows the estimated median noise PSD from the ``Test" run 
and ``Control" run respectively.
\begin{figure}[hbt!]
\centering
\includegraphics[width=\textwidth]{noise_psd_4s_run}
\caption{
	Median noise power spectral density reported from the ``Test" run (with $4$s PSD-FFT-LENGTH).
}
\label{fig:gstlal_4s_run_psd}
\index{figures}
\end{figure}
\begin{figure}[hbt!]
\centering
\includegraphics[width=\textwidth]{noise_psd_32s_run}
\caption{
	Median noise power spectral density reported from the ``Control" run (with $32$s PSD-FFT-LENGTH).
}
\label{fig:gstlal_32s_run_psd}
\index{figures}
\end{figure}
We can see that (1) the PSD from the ``Control" run shows more refined features (e.g. around $20$Hz) than that
from the ``Test" run, and (2) the binary-neutron-star merger sensitivity ranges reported from the ``Test" run is
slightly larger those reported from the ``Control" run. 

In terms of injection recovery, out of $39387$ injections from the injection set, 
the ``Control" run recovered $12913$ ($32.7\%$) of the injections,
whereas the ``Test" run recovered $13096$ ($33.2\%$) of the injections.
The ``Test" run performs marginally better than the ``Control" run in terms of recovering injections.

However, it should be noted that the results presented here are preliminary and further in-depth,
robust tests are left as future work to fully investigate the effect of changing the PSD-FFT-LENGTH.


%\section{(Ongoing work) Investigating the effect on the estimation of GstLAL's search sensitivity by not filtering injections using templates with template parameters differ significantly from the injection parameters}
%\subsection{\underline{Introduction and motivation}}
%\subsection{\underline{Setup of the control and test runs}}
%\subsection{\underline{Expected results}}

\section{(Future work) Improving the likelihood ratio statistic with the inclusion of sky location information}
\subsection{\underline{Outline and motivation}}

\section{(Future work) Towards a better ``fast path cut" to reduce the number of signal triggers for follow-up}


%\begin{figure}[hbt!]
%\centering
%\includegraphics[width=\textwidth]{cross_polarization.png}
%\caption{Cross Polarization.}\label{fig:cross_polarization}
%\index{figures}
%\end{figure}

